#include "stdafx.h"
#include "BIN2HEX.h"
#include "BIN2HEXDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CBIN2HEXDlg::CBIN2HEXDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBIN2HEXDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBIN2HEXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_BIN_FILES, _listBinFiles);
}

BEGIN_MESSAGE_MAP(CBIN2HEXDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CBIN2HEXDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CBIN2HEXDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_ALL, &CBIN2HEXDlg::OnBnClickedButtonDeleteAll)
END_MESSAGE_MAP()


BOOL CBIN2HEXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemText (IDC_EDIT_HEXA_FILE_NAME, "hex.cpp");
	SetDlgItemInt  (IDC_EDIT_HEXA_NEWLINE, 16);
	CheckDlgButton (IDC_CHECK_ADD_COMMENT, BST_CHECKED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBIN2HEXDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBIN2HEXDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

char *GetFileName (char *path)
{
	char *name = path;

	for ( ; *path; path++) {
        if (*path == '/' || *path == '\\') name = path + 1;
    } 
    return name;
}
    
void MakeValidC_ID (char *name) 
{
	for (char *p = name; *p; p++) {
		if (p==name) {
			if (isalpha (*p) || *p == '_');
			else *p = '_';
		}
		else {
			if (isalpha (*p) || *p == '_' || isdigit (*p));
			else *p = '_';
		}
	}
}

void CBIN2HEXDlg::OnBnClickedOk()
{
	int count = _listBinFiles.GetCount();
	if (count > 0) {
		char hexaFile[MAX_PATH+1];
		GetDlgItemText (IDC_EDIT_HEXA_FILE_NAME, hexaFile, MAX_PATH);
		hexaFile[MAX_PATH] = 0;
		int newLine = GetDlgItemInt  (IDC_EDIT_HEXA_NEWLINE);
		bool comment = IsDlgButtonChecked (IDC_CHECK_ADD_COMMENT) == BST_CHECKED;

		if (newLine < 1) newLine = 1;
		if (newLine > 800) newLine = 800;
		char *buf = new char [newLine];

		FILE *hex = fopen (hexaFile, "wt");
		if (hex) {
			for (int i=0; i<count; i++) {
				char binFile[MAX_PATH+1];
				_listBinFiles.GetText (i, binFile);
				binFile[MAX_PATH] = 0;
				
				char binFileName[MAX_PATH+1];
				strcpy (binFileName, GetFileName(binFile));
				binFileName[MAX_PATH] = 0;
				MakeValidC_ID (binFileName);

				FILE *bin = fopen (binFile, "rb");
				if (bin) {
					fprintf (hex, "const char *%s = { ", binFileName);
					if (comment) fprintf (hex, "\t\t//\t%s", binFile);
					fprintf (hex, "\n");

					while (1) {
						int n = fread (buf, 1, newLine, bin);
						if (n <= 0) break;
						else {
							fprintf (hex, "\t");
							for (int j=0; j<n; j++) {
								fprintf (hex, "0x%02X, ", (int)(unsigned char)buf[j]);
							}
							if (comment) {
								fprintf (hex, "\t//\t");
								for (int j=0; j<n; j++) {
									int c = (int)(unsigned char)buf[j];
									fprintf (hex, "%c", (32 <= c && c <= 126) ? c : ' ');
								}
								fprintf (hex, " ");
							}
							fprintf (hex, "\n");
						}
					}
					fprintf (hex, "}; \n\n");
					fclose (bin);
				}
			}
			fclose (hex);
		}
		delete [] buf;
	}
	// OnOK();
}

void CBIN2HEXDlg::OnBnClickedCancel()
{
	OnCancel();
}

void CBIN2HEXDlg::OnBnClickedButtonDeleteAll()
{
	_listBinFiles.ResetContent ();
}
